"use strict";
// abstracting the typescript-auto-import-cache package to support our use case
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProject = exports.createProjectService = void 0;
const projectService_1 = require("typescript-auto-import-cache/out/5_0/projectService");
const project_1 = require("typescript-auto-import-cache/out/5_0/project");
const project_2 = require("typescript-auto-import-cache/out/5_3/project");
const typescript_1 = __importDefault(require("typescript"));
function createProjectService(system, hostConfiguration) {
    const version = typescript_1.default.version.split('.');
    const major = parseInt(version[0]);
    if (major < 5) {
        return undefined;
    }
    const projectService = (0, projectService_1.createProjectService)(typescript_1.default, system, system.getCurrentDirectory(), hostConfiguration, typescript_1.default.LanguageServiceMode.Semantic);
    return projectService;
}
exports.createProjectService = createProjectService;
function createProject(host, createLanguageService, options) {
    const version = typescript_1.default.version.split('.');
    const major = parseInt(version[0]);
    const minor = parseInt(version[1]);
    if (major < 5) {
        return undefined;
    }
    const factory = minor < 3 ? project_1.createProject : project_2.createProject;
    const project = factory(typescript_1.default, host, createLanguageService, options);
    const proxyMethods = [
        'getCachedExportInfoMap',
        'getModuleSpecifierCache',
        'getGlobalTypingsCacheLocation',
        'getSymlinkCache',
        'getPackageJsonsVisibleToFile',
        'getPackageJsonAutoImportProvider',
        'includePackageJsonAutoImports',
        'useSourceOfProjectReferenceRedirect'
    ];
    proxyMethods.forEach((key) => (host[key] = project[key].bind(project)));
    if (host.log) {
        project.log = host.log.bind(host);
    }
    return project;
}
exports.createProject = createProject;
//# sourceMappingURL=serviceCache.js.map