/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.normalizeMarkupContent = void 0;
    function normalizeMarkupContent(input) {
        if (!input) {
            return undefined;
        }
        if (typeof input === 'string') {
            return {
                kind: 'markdown',
                value: input
            };
        }
        return {
            kind: 'markdown',
            value: input.value
        };
    }
    exports.normalizeMarkupContent = normalizeMarkupContent;
});
